SET ECHO ON;
SET TIME ON;
SET TIMING ON;

ALTER TABLE "DEMO_USR"."D_PRODUCT_SUB_FAMILY" DISABLE CONSTRAINT "FK_PRODUCT_FAMILY";
ALTER TABLE "DEMO_USR"."D_PRODUCT" DISABLE CONSTRAINT "FK_PRODUCT_SUB_FAMILY";
ALTER TABLE "DEMO_USR"."D_REGION" DISABLE CONSTRAINT "FK_COUNTRY";
ALTER TABLE "DEMO_USR"."D_AGENCY" DISABLE CONSTRAINT "FK_REGION";
ALTER TABLE "DEMO_USR"."D_VENDOR" DISABLE CONSTRAINT "FK_AGENCY";
ALTER TABLE "DEMO_USR"."D_CUSTOMER_SUB_GROUP" DISABLE CONSTRAINT "FK_CUSTOMER_GROUP";
ALTER TABLE "DEMO_USR"."D_CUSTOMER" DISABLE CONSTRAINT "FK_CUSTOMER_SUB_GROUP";
ALTER TABLE "DEMO_USR"."F_SALE" DISABLE CONSTRAINT "FK_DATE";
ALTER TABLE "DEMO_USR"."F_SALE" DISABLE CONSTRAINT "FK_PRODUCT";
ALTER TABLE "DEMO_USR"."F_SALE" DISABLE CONSTRAINT "FK_VENDOR";
ALTER TABLE "DEMO_USR"."F_SALE" DISABLE CONSTRAINT "FK_CUSTOMER";

TRUNCATE TABLE "DEMO_USR"."D_CUSTOMER_GROUP";
TRUNCATE TABLE "DEMO_USR"."D_CUSTOMER_SUB_GROUP";
TRUNCATE TABLE "DEMO_USR"."D_CUSTOMER";
TRUNCATE TABLE "DEMO_USR"."D_COUNTRY";
TRUNCATE TABLE "DEMO_USR"."D_REGION";
TRUNCATE TABLE "DEMO_USR"."D_AGENCY";
TRUNCATE TABLE "DEMO_USR"."D_VENDOR";
TRUNCATE TABLE "DEMO_USR"."D_PRODUCT_FAMILY";
TRUNCATE TABLE "DEMO_USR"."D_PRODUCT_SUB_FAMILY";
TRUNCATE TABLE "DEMO_USR"."D_PRODUCT";
TRUNCATE TABLE "DEMO_USR"."D_CALENDAR";
TRUNCATE TABLE "DEMO_USR"."F_SALE";

INSERT INTO "DEMO_USR"."F_SALE"
(
SAL_ID
,SAL_AMOUNT
,SAL_DISCOUNT_AMOUNT
,SAL_DATETIME
,SAL_DATE
,SAL_PRODUCT
,SAL_VENDOR
,SAL_CUSTOMER
)
SELECT
ROWNUM
,MOD(ROWNUM, 100)
,MOD(ROWNUM, 100) * (CASE WHEN MOD(ROWNUM, 100000) < 25000 THEN 0.1 WHEN MOD(ROWNUM, 100000) < 50000 THEN 0.2 WHEN MOD(ROWNUM, 100000) < 75000 THEN 0.3 ELSE 0.4 END)
,TO_DATE('01/01/2000', 'DD/MM/YYYY') + ROWNUM/(315)
,TRUNC(TO_DATE('01/01/2000', 'DD/MM/YYYY') + ROWNUM/(315))
,CASE WHEN MOD(ROWNUM, 1000) < 100 THEN 'PROD1' WHEN MOD(ROWNUM, 1000) < 200 THEN 'PROD2' WHEN MOD(ROWNUM, 1000) < 300 THEN 'PROD3' WHEN MOD(ROWNUM, 1000) < 400 THEN 'PROD4' WHEN MOD(ROWNUM, 1000) < 500 THEN 'PROD5' WHEN MOD(ROWNUM, 1000) < 600 THEN 'PROD6' WHEN MOD(ROWNUM, 1000) < 700 THEN 'PROD7' WHEN MOD(ROWNUM, 1000) < 800 THEN 'PROD8' WHEN MOD(ROWNUM, 1000) < 900 THEN 'PROD9'  ELSE 'PROD10' END
,CASE WHEN MOD(ROWNUM, 100) < 15 THEN 'VEN1' WHEN MOD(ROWNUM, 1000) < 30 THEN 'VEN2' WHEN MOD(ROWNUM, 1000) < 45 THEN 'VEN3'  WHEN MOD(ROWNUM, 1000) < 60 THEN 'VEN4' WHEN MOD(ROWNUM, 1000) < 75 THEN 'VEN5' WHEN MOD(ROWNUM, 1000) < 90 THEN 'VEN6' ELSE 'VEN7' END
,'CUS'||LPAD(To_CHAR(MOD(ROWNUM,20000)), 7, '0')
FROM
ALL_OBJECTS T1, ALL_OBJECTS T2
WHERE ROWNUM<=1000000
;

/*
DECLARE
v_count number(8,0);
BEGIN
FOR v_count IN 0..400000 LOOP
INSERT INTO "DEMO_USR"."F_SALE"
(
SAL_ID
,SAL_AMOUNT
,SAL_DISCOUNT_AMOUNT
,SAL_DATETIME
,SAL_DATE
,SAL_PRODUCT
,SAL_VENDOR
,SAL_CUSTOMER
)
VALUES
(
v_count
,MOD(v_count, 100)
,MOD(v_count, 100) * (CASE WHEN MOD(v_count, 100000) < 25000 THEN 0.1 WHEN MOD(v_count, 100000) < 50000 THEN 0.2 WHEN MOD(v_count, 100000) < 75000 THEN 0.3 ELSE 0.4 END)
,TO_DATE('01/01/2000', 'DD/MM/YYYY') + v_count/(315)
,TRUNC(TO_DATE('01/01/2000', 'DD/MM/YYYY') + v_count/(315))
,CASE WHEN MOD(v_count, 1000) < 100 THEN 'PROD1' WHEN MOD(v_count, 1000) < 200 THEN 'PROD2' WHEN MOD(v_count, 1000) < 300 THEN 'PROD3' WHEN MOD(v_count, 1000) < 400 THEN 'PROD4' WHEN MOD(v_count, 1000) < 500 THEN 'PROD5' WHEN MOD(v_count, 1000) < 600 THEN 'PROD6' WHEN MOD(v_count, 1000) < 700 THEN 'PROD7' WHEN MOD(v_count, 1000) < 800 THEN 'PROD8' WHEN MOD(v_count, 1000) < 900 THEN 'PROD9'  ELSE 'PROD10' END
,CASE WHEN MOD(v_count, 100) < 15 THEN 'VEN1' WHEN MOD(v_count, 1000) < 30 THEN 'VEN2' WHEN MOD(v_count, 1000) < 45 THEN 'VEN3'  WHEN MOD(v_count, 1000) < 60 THEN 'VEN4' WHEN MOD(v_count, 1000) < 75 THEN 'VEN5' WHEN MOD(v_count, 1000) < 90 THEN 'VEN6' ELSE 'VEN7' END
,'CUS'||LPAD(To_CHAR(MOD(v_count,20000)), 7, '0')
);
END LOOP;
commit;
End;
/
*/


INSERT INTO "DEMO_USR"."D_CALENDAR"
(
CAL_DATE
,CAL_DAY_OF_WEEK
,CAL_YEARMONTH
,CAL_MONTH_OF_YEAR
,CAL_MONTH_OF_YEAR_DESC
,CAL_YEAR
,CAL_YEAR_DESC
)
SELECT
DISTINCT
SAL_DATE
,CASE TO_CHAR(SAL_DATE, 'D') WHEN '1' THEN 'Monday' WHEN '2' THEN 'Tuesday' WHEN '3' THEN 'Wednesday' WHEN '4' THEN 'Thursday' WHEN '5' THEN 'Friday' WHEN '6' THEN 'Saturday' WHEN '7' THEN 'Sunday' Else 'N/A' END 
,TO_NUMBER(TO_CHAR(SAL_DATE, 'YYYYMM'))
,EXTRACT(MONTH FROM SAL_DATE)
,CASE EXTRACT(MONTH FROM SAL_DATE) WHEN 1 THEN 'January' WHEN 2 THEN 'February' WHEN 3 THEN 'March' WHEN 4 THEN 'April' WHEN 5 THEN 'May' WHEN 6 THEN 'June' WHEN 7 THEN 'July' WHEN 8 THEN 'August' WHEN 9 THEN 'September' WHEN 10 THEN 'October' WHEN 11 THEN 'November' WHEN 12 THEN 'December' ELSE 'N/A' END
,TO_NUMBER(TO_CHAR(SAL_DATE, 'YYYY'))
,'Year '||TO_CHAR(SAL_DATE, 'YYYY')
FROM
"DEMO_USR"."F_SALE"
;

INSERT INTO "DEMO_USR"."D_PRODUCT"
(
PRO_ID
,PRO_SUB_FAMILY
,PRO_DESC
)
SELECT
DISTINCT
SAL_PRODUCT
,CASE WHEN SAL_PRODUCT IN ('PROD1', 'PROD2', 'PROD3') THEN 'SUBFAM1' WHEN SAL_PRODUCT IN ('PROD4', 'PROD5', 'PROD6') THEN 'SUBFAM2' WHEN SAL_PRODUCT IN ('PROD7', 'PROD8', 'PROD9') THEN 'SUBFAM3' WHEN SAL_PRODUCT IN ('PROD10') THEN 'SUBFAM4' Else 'N/A' END 
,REPLACE(SAL_PRODUCT, 'PROD', 'Product ')
FROM
"DEMO_USR"."F_SALE"
;

INSERT INTO "DEMO_USR"."D_PRODUCT_SUB_FAMILY"
(
PSF_ID
,PSF_FAMILY
,PSF_DESC
)
SELECT
DISTINCT
PRO_SUB_FAMILY
,CASE WHEN PRO_SUB_FAMILY IN ('SUBFAM1', 'SUBFAM2') THEN 'FAM1' WHEN PRO_SUB_FAMILY IN ('SUBFAM3', 'SUBFAM4') THEN 'FAM2' Else 'N/A' END 
,REPLACE(PRO_SUB_FAMILY, 'SUBFAM', 'Sub-Family ')
FROM
"DEMO_USR"."D_PRODUCT"
;

INSERT INTO "DEMO_USR"."D_PRODUCT_FAMILY"
(
PFM_ID
,PFM_DESC
)
SELECT
DISTINCT
PSF_FAMILY
,REPLACE(PSF_FAMILY, 'FAM', 'Family ')
FROM
"DEMO_USR"."D_PRODUCT_SUB_FAMILY"
;


INSERT INTO "DEMO_USR"."D_VENDOR"
(
VDR_ID
,VDR_AGENCY
,VDR_NAME
)
SELECT
DISTINCT
SAL_VENDOR
,decode(SAL_VENDOR, 'VEN1', 'AGC1', 'VEN2', 'AGC1', 'VEN3', 'AGC2', 'VEN4', 'AGC2', 'VEN5', 'AGC3', 'VEN6', 'AGC4', 'VEN7', 'AGC5', 'AGC6')
,REPLACE(SAL_VENDOR, 'VEN', 'Vendor ')
FROM
"DEMO_USR"."F_SALE"
;

INSERT INTO "DEMO_USR"."D_AGENCY"
(
AGC_ID
,AGC_REGION
,AGC_NAME
)
SELECT
DISTINCT
VDR_AGENCY
,decode(VDR_AGENCY, 'AGC1', 'REG1', 'AGC2', 'REG1', 'AGC3', 'REG2', 'AGC4', 'REG2', 'AGC5', 'REG3', 'AGC6', 'REG4', 'REG5')
,REPLACE(VDR_AGENCY, 'AGC', 'Agency ')
FROM
"DEMO_USR"."D_VENDOR"
;

INSERT INTO "DEMO_USR"."D_REGION"
(
REG_ID
,REG_COUNTRY
,REG_NAME
)
SELECT
DISTINCT
AGC_REGION
,decode(AGC_REGION, 'REG1', 'CTR1', 'REG2', 'CTR1', 'REG3', 'CTR2', 'REG4', 'CTR2', 'REG5', 'CTR3', 'CTR4')
,REPLACE(AGC_REGION, 'REG', 'Region ')
FROM
"DEMO_USR"."D_AGENCY"
;

INSERT INTO "DEMO_USR"."D_COUNTRY"
(
CTR_ID
,CTR_NAME
)
SELECT
DISTINCT
REG_COUNTRY
,REPLACE(REG_COUNTRY, 'CTR', 'Country ')
FROM
"DEMO_USR"."D_REGION"
;


INSERT INTO "DEMO_USR"."D_CUSTOMER"
(
CUS_ID
,CUS_SUB_GROUP
,CUS_NAME
)
SELECT
DISTINCT
SAL_CUSTOMER
,CASE WHEN TO_NUMBER(REPLACE(SAL_CUSTOMER, 'CUS', '')) < 100 THEN 'CSB1' WHEN MOD(TO_NUMBER(REPLACE(SAL_CUSTOMER, 'CUS', '')),10) < 5 THEN 'CSB2' ELSE 'CSB3' END
,REPLACE(SAL_CUSTOMER, 'CUS', 'Customer ')
FROM
"DEMO_USR"."F_SALE"
;

INSERT INTO "DEMO_USR"."D_CUSTOMER_SUB_GROUP"
(
CSB_ID
,CSB_GROUP
,CSB_DESC
)
SELECT
DISTINCT
CUS_SUB_GROUP
,decode(CUS_SUB_GROUP, 'CSB1', 'CGR1', 'CSB2', 'CGR2', 'CSB3', 'CGR3', 'CGR4')
,REPLACE(CUS_SUB_GROUP, 'CSB', 'Sub-Group ')
FROM
"DEMO_USR"."D_CUSTOMER"
;

INSERT INTO "DEMO_USR"."D_CUSTOMER_GROUP"
(
CGR_ID
,CGR_DESC
)
SELECT
DISTINCT
CSB_GROUP
,REPLACE(CSB_GROUP, 'CGR', 'Group ')
FROM
"DEMO_USR"."D_CUSTOMER_SUB_GROUP"
;

ALTER TABLE "DEMO_USR"."D_PRODUCT_SUB_FAMILY" ENABLE CONSTRAINT "FK_PRODUCT_FAMILY";
ALTER TABLE "DEMO_USR"."D_PRODUCT" ENABLE CONSTRAINT "FK_PRODUCT_SUB_FAMILY";
ALTER TABLE "DEMO_USR"."D_REGION" ENABLE CONSTRAINT "FK_COUNTRY";
ALTER TABLE "DEMO_USR"."D_AGENCY" ENABLE CONSTRAINT "FK_REGION";
ALTER TABLE "DEMO_USR"."D_VENDOR" ENABLE CONSTRAINT "FK_AGENCY";
ALTER TABLE "DEMO_USR"."D_CUSTOMER_SUB_GROUP" ENABLE CONSTRAINT "FK_CUSTOMER_GROUP";
ALTER TABLE "DEMO_USR"."D_CUSTOMER" ENABLE CONSTRAINT "FK_CUSTOMER_SUB_GROUP";
ALTER TABLE "DEMO_USR"."F_SALE" ENABLE CONSTRAINT "FK_DATE";
ALTER TABLE "DEMO_USR"."F_SALE" ENABLE CONSTRAINT "FK_PRODUCT";
ALTER TABLE "DEMO_USR"."F_SALE" ENABLE CONSTRAINT "FK_VENDOR";
ALTER TABLE "DEMO_USR"."F_SALE" ENABLE CONSTRAINT "FK_CUSTOMER";

COMMIT;
