Set echo on;
Set autotrace off;
Set time on;
Set timing on;

DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL4_001";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL3_001";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL3_002";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL3_003";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL3_004";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_001";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_002";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_003";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_004";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_005";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_006";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL1_001";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL1_002";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL1_003";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL1_004";
DROP MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL0_001";


exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'F_SALE');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_CUSTOMER');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_CUSTOMER_SUB_GROUP');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_CUSTOMER_GROUP');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_VENDOR');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_AGENCY');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_REGION');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_COUNTRY');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_PRODUCT');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_PRODUCT_SUB_FAMILY');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_PRODUCT_FAMILY');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'D_CALENDAR');

exec DBMS_STATS.GATHER_INDEX_STATS('DEMO_USR', 'IDX_SALE_DIM1');
exec DBMS_STATS.GATHER_INDEX_STATS('DEMO_USR', 'IDX_SALE_ALL_DIM');


CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL4_001"
build immediate
enable query rewrite
AS
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3, 4;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL3_001"
build immediate
enable query rewrite
AS
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_VENDOR
ORDER BY
	1, 2, 3;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL3_002"
build immediate
enable query rewrite
AS
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL3_003"
build immediate
enable query rewrite
AS
SELECT
	SAL_DATE,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL3_004"
build immediate
enable query rewrite
AS
SELECT
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2, 3;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_001"
build immediate
enable query rewrite
AS
SELECT
	SAL_DATE,
	SAL_PRODUCT,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_PRODUCT
ORDER BY
	1, 2;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_002"
build immediate
enable query rewrite
AS
SELECT
	SAL_DATE,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_VENDOR
ORDER BY
	1, 2;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_003"
build immediate
enable query rewrite
AS
SELECT
	SAL_PRODUCT,
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_VENDOR
ORDER BY
	1, 2;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_004"
build immediate
enable query rewrite
AS
SELECT
	SAL_DATE,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE,
	SAL_CUSTOMER
ORDER BY
	1, 2;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_005"
build immediate
enable query rewrite
AS
SELECT
	SAL_PRODUCT,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT,
	SAL_CUSTOMER
ORDER BY
	1, 2;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL2_006"
build immediate
enable query rewrite
AS
SELECT
	SAL_VENDOR,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_VENDOR,
	SAL_CUSTOMER
ORDER BY
	1, 2;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL1_001"
build immediate
enable query rewrite
AS
SELECT
	SAL_DATE,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_DATE
ORDER BY
	1;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL1_002"
build immediate
enable query rewrite
AS
SELECT
	SAL_PRODUCT,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_PRODUCT
ORDER BY
	1;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL1_003"
build immediate
enable query rewrite
AS
SELECT
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_VENDOR
ORDER BY
	1;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL1_004"
build immediate
enable query rewrite
AS
SELECT
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
GROUP BY
	SAL_CUSTOMER
ORDER BY
	1;

CREATE MATERIALIZED VIEW "DEMO_USR"."MV_SALE_MODEL_LVL0_001"
build immediate
enable query rewrite
AS
SELECT
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
;


exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL4_001');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL3_001');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL3_002');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL3_003');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL3_004');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL2_001');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL2_002');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL2_003');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL2_004');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL2_005');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL2_006');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL1_001');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL1_002');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL1_003');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL1_004');
exec DBMS_STATS.GATHER_TABLE_STATS('DEMO_USR', 'MV_SALE_MODEL_LVL0_001');
