Set echo on;
Set autotrace on;
Set time on;
Set timing on;

ALTER SESSION set query_rewrite_integrity = TRUSTED;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
WHERE
	SAL_DATE >= '01/01/2005'
	AND SAL_DATE < '01/01/2006'
GROUP BY
	SAL_VENDOR
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_VENDOR,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
WHERE
	SAL_DATE >= '01/01/2005'
	AND SAL_DATE < '01/01/2006'
GROUP BY
	SAL_VENDOR
ORDER BY
	1
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_PRODUCT,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
WHERE SAL_CUSTOMER = 'CUS0000001'
GROUP BY
	SAL_PRODUCT,
	SAL_CUSTOMER
ORDER BY
	1, 2
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_PRODUCT,
	SAL_CUSTOMER,
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
WHERE SAL_CUSTOMER = 'CUS0000001'
GROUP BY
	SAL_PRODUCT,
	SAL_CUSTOMER
ORDER BY
	1, 2
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_PRODUCT,
	TO_CHAR(SAL_DATETIME, 'HH24'),
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
WHERE SAL_VENDOR IN ( 'VEN1', 'VEN2')
GROUP BY
	SAL_PRODUCT,
	TO_CHAR(SAL_DATETIME, 'HH24')
ORDER BY
	1, 2
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_PRODUCT,
	TO_CHAR(SAL_DATETIME, 'HH24'),
	COUNT(*),
	sum(SAL_AMOUNT),
	sum(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
WHERE SAL_VENDOR IN ( 'VEN1', 'VEN2')
GROUP BY
	SAL_PRODUCT,
	TO_CHAR(SAL_DATETIME, 'HH24')
ORDER BY
	1, 2
)
WHERE ROWNUM <= 10;


alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'false';

select * from
(
SELECT
	SAL_VENDOR,
	COUNT(*),
	avg(SAL_AMOUNT),
	min(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
WHERE
	SAL_DATE >= '01/01/2005'
	AND SAL_DATE < '01/01/2006'
GROUP BY
	SAL_VENDOR
ORDER BY
	1
)
WHERE ROWNUM <= 10;

alter system flush buffer_cache;
ALTER SESSION SET QUERY_REWRITE_ENABLED = 'true';

select * from
(
SELECT
	SAL_VENDOR,
	COUNT(*),
	avg(SAL_AMOUNT),
	min(SAL_DISCOUNT_AMOUNT)
FROM
	"DEMO_USR"."F_SALE"
WHERE
	SAL_DATE >= '01/01/2005'
	AND SAL_DATE < '01/01/2006'
GROUP BY
	SAL_VENDOR
ORDER BY
	1
)
WHERE ROWNUM <= 10;
